//
//  AppDelegate.m
//  calc
//
//  Created by Loay Setrak on 2/08/13.
//  Copyright (c) 2013 Loay Setrak. All rights reserved.
//

#import "AppDelegate.h"

@implementation AppDelegate

- (IBAction)push_subtract:(id)sender {
    if ([a_button state] == NSOnState || [m_button state] == NSOnState || [d_button state] == NSOnState)
        [s_button setState:NSOffState];
    else {
        [self check_calc_model];
        
        if (!conv_model.first_call)
            [self push_equal:0];
        
        conv_model.sign_state = 's';
        [conv_model computeNewDisplayVal:[conv_display floatValue]];
        [conv_display setFloatValue:conv_model.running_total];
    }
}

- (IBAction)push_add:(id)sender {
    if ([m_button state] == NSOnState || [s_button state] == NSOnState || [d_button state] == NSOnState) {
        [a_button setState:NSOffState];
    }
    else {
        [self check_calc_model];
        
        if (!conv_model.first_call)
            [self push_equal:0];
        
        conv_model.sign_state = 'a';
        [conv_model computeNewDisplayVal:[conv_display floatValue]];
        [conv_display setFloatValue:conv_model.running_total];
    }
}

- (IBAction)Push_multiply:(id)sender {
    if ([a_button state] == NSOnState || [s_button state] == NSOnState || [d_button state] == NSOnState)
        [m_button setState:NSOffState];
    else {
        [self check_calc_model];
        
        if (!conv_model.first_call)
            [self push_equal:0];
        
        conv_model.sign_state = 'm';
        [conv_model computeNewDisplayVal:[conv_display floatValue]];
        [conv_display setFloatValue:conv_model.running_total];
    }
}

- (IBAction)push_divide:(id)sender {
    if ([a_button state] == NSOnState || [s_button state] == NSOnState || [m_button state] == NSOnState) {
        [d_button setState:NSOffState];
    }
    else {
        [self check_calc_model];
        
        if (!conv_model.first_call)
            [self push_equal:0];
        
        conv_model.sign_state = 'd';
        [conv_model computeNewDisplayVal:[conv_display floatValue]];
        [conv_display setFloatValue:conv_model.running_total];
    }
}


- (IBAction)push_zero:(id)sender {
    [self push_number:sender];
}

- (IBAction)push_one:(id)sender {
    [self push_number:sender];
}

- (IBAction)push_two:(id)sender {
    [self push_number:sender];
}

- (IBAction)push_three:(id)sender {
    [self push_number:sender];
}

- (IBAction)push_four:(id)sender {
    [self push_number:sender];
}

- (IBAction)push_five:(id)sender {
    [self push_number:sender];
}

- (IBAction)push_six:(id)sender {
    [self push_number:sender];
}

- (IBAction)push_seven:(id)sender {
    [self push_number:sender];
}

- (IBAction)push_eight:(id)sender {
    [self push_number:sender];
}

- (IBAction)push_nine:(id)sender {
    [self push_number:sender];
}

- (void)     push_number:    (id) sender {
    if ([self sign_pushed]) {
        [a_button setState:0];
        [d_button setState:0];
        [m_button setState:0];
        [s_button setState:0];
        [conv_display setStringValue:@""];
    }
    
    if ([[conv_display stringValue] compare:@"0"] && !conv_model.first_call)
        [conv_display setStringValue:[[conv_display stringValue] stringByAppendingString:[sender title]]];
    else
        [conv_display setStringValue:[sender title]];
}
- (BOOL)     sign_pushed {
    if ([a_button state] == NSOnState || [s_button state] == NSOnState || [m_button state] == NSOnState || [d_button state] == NSOnState)
        return YES;
    else return NO;
}
- (void)     check_calc_model {
    @try {
        if (conv_model == nil) {
            conv_model = [[ConvModel alloc] init];
            conv_model.first_call = YES;
        }
    }
    @catch (NSException *ex) {
        NSLog(@"check_calc_model: Caught %@: %@", [ex name], [ex reason]);
    }
}

- (IBAction) push_clear:    (id) sender {
    if ((conv_model = nil)) {
        conv_model = nil;
    }
    
    [conv_display setIntValue:0];
    
    if ([self sign_pushed]) {
        [a_button setState:0];
        [d_button setState:0];
        [m_button setState:0];
        [s_button setState:0];
    }
}
- (IBAction) push_equal:    (id) sender {
    [self check_calc_model];
    [conv_model computeNewDisplayVal:[conv_display floatValue]];
    [conv_display setFloatValue:conv_model.running_total];
    conv_model.first_call = YES;
}
- (IBAction) push_decimal:    (id) sender {
    if ([self sign_pushed]) {
        [a_button setState:0];
        [d_button setState:0];
        [m_button setState:0];
        [s_button setState:0];
        [conv_display setStringValue:@""];
    }
    
    [conv_display setStringValue:[[conv_display stringValue] stringByAppendingString:@"."]];
}

-(IBAction)Back:(id)sender {
    NSString *backspace = conv_display;
	float lengthofstring = backspace.length;
	backspace = [backspace substringToIndex:lengthofstring - 1];
	conv_display = backspace;
}


@end
